% ForcedError2.m
%
% This script forces the generation of an MException.
%
% Created by Dr. C. S. Tritt
% Last revised: 12/6/11 (v. 1.0)

% Start with a clean workspace and command window.
clear all; clc;

try
   try
      % Force an error. Show dynamic message construction.
      a = 1; b = 'abc';
      error('AcmeSoft:DemoError', 'Test message: %i & %s', a, b);
   catch myException
      % Try something else. Pretend it didn't work, so create and throw a  
      % higher order exception.
      newException = MException('AcmeSoft:HigherOrderError', ...
         'Second try didn''t work either.');
      newException = addCause(newException, myException);
      throw(newException)
   end
catch nE % nE will contain a copy of the exception thrown.
   fprintf('Higher order error caught and processed...\n');
   disp(nE); % The MException caught.
   disp(nE.stack(1)); % Its stack. Shows throw was on line 21.
   disp(nE.cause{1}); % Its cause was myException.
   disp(nE.cause{1}.stack(1)); % The cause's stack (line 14).
   disp(nE.getReport) % Display report - explained later in the slide deck.
end